import { DesignerHostService } from '../../designer-canvas';
import { ExtractPropTypes } from "vue";
export declare const fieldColumns: {
    field: string;
    title: string;
}[];
export declare const variableColumns: {
    field: string;
    title: string;
}[];
export declare const bindingTypes: {
    value: string;
    text: string;
}[];
export interface BindingSelectorService {
    getData(params: any): Promise<any>;
}
export interface BindingTypeOption {
    enable: boolean;
    data: Array<{
        [key: string]: string;
    }>;
    value: string;
    textField: string;
    valueField: string;
}
export interface BindingSelectorEditorParams {
    /** 已选控件schema */
    componentSchema: any;
    /** 已选字段是否需要同步至表单viemodel.fields节点 */
    needSyncToViewModel: {
        type: boolean;
        default: false;
    };
    /** 当前控件所属的视图模型id */
    viewModelId: {
        type: string;
        default: '';
    };
    /** 设计器服务类 */
    designerHostService: {
        type: DesignerHostService;
    };
    /** 表单中已使用的字段是否需要设置为禁用 */
    disableOccupiedFields: {
        type: boolean;
        default: false;
    };
    /** 是否可以变更字段类型 */
    canChangeFieldType?: boolean;
}
export declare const bindingSelectorProps: Record<string, any>;
export type BindingSelectorProps = ExtractPropTypes<typeof bindingSelectorProps>;
export declare const propsResolver: (schemaValue?: Record<string, any>, mergeDefaults?: boolean) => Record<string, any>;
