/**
 * Copyright (c) 2020 - present, Inspur Genersoft Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { ExtractPropTypes, PropType } from 'vue';
export type ButtonType = 'primary' | 'warning' | 'danger' | 'success' | 'link' | 'secondary';
export type ButtonSize = 'small' | 'large' | 'middle';
export declare const buttonProps: {
    /**
     * 组件标识
     */
    id: StringConstructor;
    /**
     * 设置按钮类型
     */
    type: {
        type: PropType<ButtonType>;
        default: string;
    };
    /**
     * 是否禁用
     */
    disabled: {
        type: BooleanConstructor;
        default: boolean;
    };
    /**
     * 按钮尺寸
     */
    size: {
        type: PropType<ButtonSize>;
        default: string;
    };
    /**
     * 按钮图标
     */
    icon: {
        type: StringConstructor;
    };
    /**
     * 自定义class
     */
    customClass: {
        type: ObjectConstructor;
        default: {};
    };
};
export type ButtonProps = ExtractPropTypes<typeof buttonProps>;
