/**
 * Copyright (c) 2020 - present, Inspur Genersoft Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare function useCalculator(): {
    strip: (num: number, precision?: number) => number;
    plus: (num1: number, num2: number, ...others: number[]) => number;
    minus: (num1: number, num2: number, ...others: number[]) => number;
    times: (num1: number, num2: number, ...others: number[]) => number;
    divide: (num1: number, num2: number, ...others: number[]) => number;
    round: (num: number, ratio: number) => number;
    digitLength: (num: number) => number;
    float2Fixed: (num: number) => number;
    enableBoundaryChecking: (flag?: boolean) => void;
};
