import { ExtractPropTypes } from 'vue';
export type CapsuleColerType = 'primary' | 'secondary';
export interface CapsuleItem {
    [key: string]: any;
    /**
     * 枚举值
     */
    value: any;
    /**
     * 枚举展示文本
     */
    name: string;
    /**
     * 是否展示
     */
    show?: boolean;
    /**
    * 是否禁用
    */
    disabled?: boolean;
}
export declare const capsuleProps: Record<string, any>;
export declare const capsuleItemProps: {
    name: {
        type: StringConstructor;
        default: string;
    };
    value: {
        type: StringConstructor;
        default: string;
    };
    isActive: {
        type: BooleanConstructor;
        default: boolean;
    };
    icon: {
        type: StringConstructor;
        default: string;
    };
    index: {
        type: NumberConstructor;
        default: number;
    };
    show: {
        type: BooleanConstructor;
        default: boolean;
    };
    disabled: {
        type: BooleanConstructor;
        default: boolean;
    };
};
export type CapsuleProps = ExtractPropTypes<typeof capsuleProps>;
export type CapsuleItemProps = ExtractPropTypes<typeof capsuleItemProps>;
export declare const propsResolver: (schemaValue?: Record<string, any>, mergeDefaults?: boolean) => Record<string, any>;
