/**
 * Copyright (c) 2020 - present, Inspur Genersoft Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { ExtractPropTypes } from 'vue';
export declare const codeEditorProps: {
    /** 绑定值 */
    modelValue: {
        type: StringConstructor;
        default: string;
    };
    /** 语言 */
    language: {
        type: StringConstructor;
        default: string;
    };
    /** 主题 */
    theme: {
        type: StringConstructor;
        default: string;
    };
    /** 是否只读 */
    readonly: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 额外的 monaco-editor 配置 */
    monacoEditorOptions: {
        type: ObjectConstructor;
        default: {};
    };
    /** 配置文件路径，配置文件用于配置 monaco 资源文件的位置 */
    configPath: {
        type: StringConstructor;
        default: string;
    };
};
export type CodeEditorProps = ExtractPropTypes<typeof codeEditorProps>;
