import { Color, ColorString } from './color.class';
import { Rgba } from './rgba.class';
import { Hsla } from './hsla.class';
import { Hsva } from './hsva.class';
import { Ref } from 'vue';
export declare enum ColorType {
    hex = "hex",
    hexa = "hexa",
    rgba = "rgba",
    rgb = "rgb",
    hsla = "hsla",
    hsl = "hsl",
    cmyk = "cmyk"
}
export declare class ColorPickerControl {
    /** 所选颜色值 */
    private modelValue;
    /** 色调颜色值 */
    private hueValue;
    /** 初始颜色值 */
    private initValue;
    readonly valueChanged: Ref<Color | undefined, Color | undefined>;
    initType: ColorType;
    readonly alphaChannelVisibilityChanges: Ref<any, any>;
    private colorPresets;
    /** 确定输入颜色类型 */
    static finOutInputType: any;
    constructor(val: any);
    /** 设置值 */
    setValueFrom(color: ColorString | Color | Rgba | Hsla | Hsva, randomId: any, allowColorNull: boolean): this;
    private setHueColor;
    get hue(): Color;
    set hue(hueColor: Color);
    private setValue;
    get value(): Color;
    set value(value: Color);
    reset(): this;
    showAlphaChannel(): this;
    private finOutInputType;
    /** 设置预定义颜色 */
    setColorPresets(colorPresets: Array<Array<ColorString> | ColorString>): this;
    private setPresets;
    get presets(): (Color | Color[])[];
    hasPresets(): boolean;
}
