import { ExtractPropTypes, PropType } from "vue";
import { Option } from '../combo-list.props';
export declare const listContainerProps: {
    dataSource: {
        type: {
            (arrayLength: number): Option[];
            (...items: Option[]): Option[];
            new (arrayLength: number): Option[];
            new (...items: Option[]): Option[];
            isArray(arg: any): arg is any[];
            readonly prototype: any[];
            from<T>(arrayLike: ArrayLike<T>): T[];
            from<T_1, U>(arrayLike: ArrayLike<T_1>, mapfn: (v: T_1, k: number) => U, thisArg?: any): U[];
            from<T_2>(iterable: Iterable<T_2> | ArrayLike<T_2>): T_2[];
            from<T_3, U_1>(iterable: Iterable<T_3> | ArrayLike<T_3>, mapfn: (v: T_3, k: number) => U_1, thisArg?: any): U_1[];
            of<T_4>(...items: T_4[]): T_4[];
            readonly [Symbol.species]: ArrayConstructor;
        };
        default: never[];
    };
    enableSearch: {
        type: BooleanConstructor;
        default: boolean;
    };
    idField: {
        type: StringConstructor;
        default: string;
    };
    multiSelect: {
        type: BooleanConstructor;
        default: boolean;
    };
    selectedValues: {
        type: StringConstructor;
        default: string;
    };
    separator: {
        type: StringConstructor;
        default: string;
    };
    textField: {
        type: StringConstructor;
        default: string;
    };
    titleField: {
        type: StringConstructor;
        default: string;
    };
    width: {
        type: NumberConstructor;
    };
    maxHeight: {
        type: NumberConstructor;
    };
    valueField: {
        type: StringConstructor;
        default: string;
    };
    /** 值变化事件 */
    onSelectionChange: {
        type: FunctionConstructor;
        default: () => void;
    };
    searchOption: {
        type: PropType<boolean | ((searchText: string, option: any) => boolean)>;
        default: boolean;
    };
    enableHighlightSearch: {
        type: BooleanConstructor;
        default: boolean;
    };
};
export type ListContainerProps = ExtractPropTypes<typeof listContainerProps>;
