/**
 * Copyright (c) 2020 - present, Inspur Genersoft Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { ExtractPropTypes } from 'vue';
export interface ComboTreeHttpService {
    getData(params?: any): Promise<any[]>;
}
export interface Option {
    disabled?: boolean;
    [prop: string]: any;
}
/**
 * remote info
 */
export interface Remote {
    url: string;
    method?: 'GET' | 'POST' | 'PUT';
    headers?: any;
    body?: any;
}
/**
 * 数据展现方式
 */
export declare enum ViewType {
    Text = "text",
    Tag = "tag"
}
/**
 * 展示位置
 */
export declare const enum Placement {
    /**
     * 在控件的上方展示
     */
    top = "top",
    /**
     * 在控件底部展示
     */
    bottom = "bottom",
    /**
     * 根据控件的位置自动确认展示位置
     */
    auto = "auto"
}
/**
 * 下拉列表属性
 */
export declare const comboTreeProps: Record<string, any>;
export type ComboTreeProps = ExtractPropTypes<typeof comboTreeProps>;
export declare const propsResolver: (schemaValue?: Record<string, any>, mergeDefaults?: boolean) => Record<string, any>;
