import { SetupContext } from "vue";
import { ConditionProps } from "../condition.props";
import { UseCompare, UseFieldConfig } from "./types";
declare enum CompareType {
    Equal = "0",
    NotEqual = "1",
    Greater = "2",
    GreaterOrEqual = "3",
    Less = "4",
    LessOrEqual = "5",
    Like = "6",
    LikeStartWith = "7",
    LikeEndWith = "8",
    In = "9",
    NotIn = "10"
}
declare const CompareTypeName: {
    value: string;
    name: string;
}[];
declare const CompareTypeInEditor: {
    'button-edit': string[];
    'check-box': string[];
    'combo-list': string[];
    'combo-lookup': string[];
    'date-picker': string[];
    'date-range': never[];
    'datetime-picker': string[];
    'datetime-range': never[];
    'month-picker': string[];
    'month-range': never[];
    'year-picker': string[];
    'year-range': never[];
    'input-group': string[];
    lookup: string[];
    'number-range': never[];
    'number-spinner': string[];
    'radio-group': string[];
    text: string[];
};
export { CompareType, CompareTypeName, CompareTypeInEditor };
export declare function useCompare(props: ConditionProps, context: SetupContext, useFieldComposition: UseFieldConfig): UseCompare;
