import { DesignerHostService } from '../../../designer-canvas/src/composition/types';
import { DynamicResolver } from '../../../../components/dynamic-resolver';
import { ComponentBuildInfo } from '../../../component/src/composition/inner-component-build-info';
/**
 * 创建表格组件服务类
 */
export declare class DataGridComponentCreatorService {
    private resolver;
    private designerHostService;
    private formSchemaUtils;
    private controlCreatorUtils;
    private designViewModelUtils;
    private useFormCommand;
    private formStateMachineUtils;
    constructor(resolver: DynamicResolver, designerHostService: DesignerHostService);
    createComponent(buildInfo: ComponentBuildInfo): any;
    /**
     * 追加父容器
     * @param componentRefNode
     * @param buildInfo
     * @returns
     */
    private wrapContainerSectionForComponent;
    /**
     * 为父容器追加新增、删除按钮
     */
    private appendAddDeleteBtnToParentContainer;
    /**
     * 向视图模型添加新增删除命令
     */
    private appendAddAndDeleteCommands;
    /**
     * 获取新增删除子表命令可用的控制器id。
     */
    private resolveCommandController;
    createComponentRefNode(buildInfo: ComponentBuildInfo): any;
    createComponentNode(buildInfo: ComponentBuildInfo): any;
    /**
     * 添加viewModel节点
     */
    createViewModeNode(buildInfo: ComponentBuildInfo): any;
    /**
     * 获取表格组件层级的class样式
     */
    private getDataGridComponentClass;
    /**
     * 创建表格组件内层级结构
     */
    private createDateGridComponentContents;
    /**
     * 组装viewModel fields 节点
     */
    private assembleViewModelFields;
}
