/**
 * Copyright (c) 2020 - present, Inspur Genersoft Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { Ref, SetupContext } from 'vue';
import { UseColumn, UseDataView, UseDragColumn, UseColumnFilter, UseFilterHistory, UseFitColumn, UseGroupColumn, UseSidebar, UseSort, UseVirtualScroll, UseFilter, DataViewOptions, UseSelection, VisualData } from '../../composition/types';
export default function (props: DataViewOptions, context: SetupContext, gridContentRef: Ref<any>, leftFixedGridContentRef: Ref<any>, rightFixedGridContentRef: Ref<any>, useColumnComposition: UseColumn, useDataViewComposition: UseDataView, useDragColumnComposition: UseDragColumn, useColumnFilterComposition: UseColumnFilter, useFilterComposition: UseFilter, useFilterHistoryComposition: UseFilterHistory, useFitColumnComposition: UseFitColumn, useGroupColumnComposition: UseGroupColumn, useSelectionComposition: UseSelection, useSidebarComposition: UseSidebar, useSortComposition: UseSort, useVirtualScrollComposition: UseVirtualScroll, viewPortWidth: Ref<number>, visibleDatas: Ref<VisualData[]>): {
    renderGridHeader: () => any;
    renderGridColumnResizeOverlay: () => any;
    shouldShowHeader: import("vue").ComputedRef<boolean>;
};
