/**
 * Copyright (c) 2020 - present, Inspur Genersoft Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { ExtractPropTypes } from 'vue';
import { CalendarWeekItem } from '../../types/calendar';
export declare const datePickerCalendarProps: {
    dates: {
        Type: {
            (arrayLength: number): CalendarWeekItem[];
            (...items: CalendarWeekItem[]): CalendarWeekItem[];
            new (arrayLength: number): CalendarWeekItem[];
            new (...items: CalendarWeekItem[]): CalendarWeekItem[];
            isArray(arg: any): arg is any[];
            readonly prototype: any[];
            from<T>(arrayLike: ArrayLike<T>): T[];
            from<T_1, U>(arrayLike: ArrayLike<T_1>, mapfn: (v: T_1, k: number) => U, thisArg?: any): U[];
            from<T_2>(iterable: Iterable<T_2> | ArrayLike<T_2>): T_2[];
            from<T_3, U_1>(iterable: Iterable<T_3> | ArrayLike<T_3>, mapfn: (v: T_3, k: number) => U_1, thisArg?: any): U_1[];
            of<T_4>(...items: T_4[]): T_4[];
            readonly [Symbol.species]: ArrayConstructor;
        };
        default: never[];
    };
    daysInWeek: {
        Type: {
            (arrayLength: number): string[];
            (...items: string[]): string[];
            new (arrayLength: number): string[];
            new (...items: string[]): string[];
            isArray(arg: any): arg is any[];
            readonly prototype: any[];
            from<T>(arrayLike: ArrayLike<T>): T[];
            from<T_1, U>(arrayLike: ArrayLike<T_1>, mapfn: (v: T_1, k: number) => U, thisArg?: any): U[];
            from<T_2>(iterable: Iterable<T_2> | ArrayLike<T_2>): T_2[];
            from<T_3, U_1>(iterable: Iterable<T_3> | ArrayLike<T_3>, mapfn: (v: T_3, k: number) => U_1, thisArg?: any): U_1[];
            of<T_4>(...items: T_4[]): T_4[];
            readonly [Symbol.species]: ArrayConstructor;
        };
        default: string[];
    };
    enableKeyboadNavigate: {
        Type: BooleanConstructor;
        default: boolean;
    };
    enableMarkCurrent: {
        Type: BooleanConstructor;
        default: boolean;
    };
    enablePeriod: {
        Type: BooleanConstructor;
        default: boolean;
    };
    firstDayOfTheWeek: {
        Type: BooleanConstructor;
        default: string;
    };
    selected: {
        Type: ObjectConstructor;
        default: null;
    };
    selectedPeriod: {
        Type: ObjectConstructor;
        default: null;
    };
    selectedWeek: {
        Type: ObjectConstructor;
        default: null;
    };
    selectMode: {
        Type: StringConstructor;
        default: string;
    };
    showWeekNumber: {
        Type: BooleanConstructor;
        default: boolean;
    };
    weekTitle: {
        Type: StringConstructor;
        default: string;
    };
};
export type DatePickerCalendarProps = ExtractPropTypes<typeof datePickerCalendarProps>;
