/** 用于响应画布发生变更 */
export declare const canvasChanged: import("vue").Ref<number, number>;
/**
 * 计算选中控件的绝对位置
 */
export declare function setPositionForSelectedElement(selectElement: HTMLElement): void;
/**
 * 定位画布中已选控件的操作按钮的位置
 * @param selectElement 选中的控件元素
 */
export declare function setPositionOfButtonGroup(selectElement: HTMLElement): void;
/**
 * 隐藏元素下的按钮
 * @param selectElement
 * @returns
 */
export declare function resetPositionOfButtonGroup(selectElement: HTMLElement): void;
/**
 * 定位画布中已选控件的操作按钮的位置
 * @param containerElement 监听的父容器
 */
export declare function setPositionOfButtonGroupInContainer(containerElement: HTMLElement): void;
/**
 * 定位页面中选中控件的操作按钮位置。
 * 场景：控件内部点击收折或者切换显示内容后，需要重新计算页面中下方选中控件的按钮位置。
 * 例如点击section控件的收折图标后，需要重新计算section下方已选控件的操作按钮位置
 */
export declare function setPositionOfSelectedComponentBtnGroup(canvasElement: HTMLElement): void;
