/**
 * Copyright (c) 2020 - present, Inspur Genersoft Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { ExtractPropTypes } from 'vue';
export declare const discussionEditorProps: {
    cancelVisible: {
        Type: BooleanConstructor;
        default: boolean;
    };
    personnelsPrimaryKey: {
        Type: StringConstructor;
        default: string;
    };
    personnelsDisplayKey: {
        Type: StringConstructor;
        default: string;
    };
    replyPersonnelsDisplayKey: {
        Type: StringConstructor;
        default: string;
    };
    editHeight: {
        Type: NumberConstructor;
        default: number;
    };
    type: {
        Type: StringConstructor;
        default: string;
    };
    orgUrl: {
        Type: StringConstructor;
        default: string;
    };
    personSearchUrl: {
        Type: StringConstructor;
        default: string;
    };
    sectionData: {
        Type: ObjectConstructor;
        default: never[];
    };
    replyUser: {
        Type: ObjectConstructor;
        default: {
            id: {};
        };
    };
    personnels: {
        Type: ObjectConstructor;
        default: never[];
    };
    attachFiles: {
        Type: ObjectConstructor;
        default: never[];
    };
};
export type DiscussionEditorProps = ExtractPropTypes<typeof discussionEditorProps>;
