/**
 * Copyright (c) 2020 - present, Inspur Genersoft Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { ExtractPropTypes } from 'vue';
export declare const discussionListProps: {
    pagerOnServer: {
        Type: BooleanConstructor;
        default: boolean;
    };
    /** 是否支持分页 */
    supportPaging: {
        Type: BooleanConstructor;
        default: boolean;
    };
    /** 当前页码 */
    pageIndex: {
        Type: NumberConstructor;
        default: number;
    };
    /** 总条数 */
    total: {
        Type: NumberConstructor;
        default: number;
    };
    /** 每页显示个数 */
    pageSize: {
        Type: NumberConstructor;
        default: number;
    };
    /** 评论数据 */
    discussionData: {
        Type: ObjectConstructor;
        default: never[];
    };
    personnelsDisplayKey: {
        Type: StringConstructor;
        default: string;
    };
};
export type DiscussionListProps = ExtractPropTypes<typeof discussionListProps>;
