/**
 * Copyright (c) 2020 - present, Inspur Genersoft Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { ExtractPropTypes } from 'vue';
export declare const dropdownItemProps: {
    /** 下拉框标签 */
    label: {
        type: StringConstructor;
        default: string;
    };
    /** 下拉框名称 */
    value: {
        type: StringConstructor;
        default: string;
    };
    /** 是否禁用该下拉框属性 */
    disabled: {
        type: BooleanConstructor;
        default: boolean;
    };
    active: {
        type: BooleanConstructor;
        default: boolean;
    };
    divide: {
        type: BooleanConstructor;
        default: boolean;
    };
    onSelect: {
        type: FunctionConstructor;
        default: () => void;
    };
};
export type DropdownItemProps = ExtractPropTypes<typeof dropdownItemProps>;
