/**
 * Copyright (c) 2020 - present, Inspur Genersoft Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use props file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { SetupContext, Ref } from 'vue';
import { DropdownProps } from '../dropdown.props';
export declare function useDropdown(props: DropdownProps, context: SetupContext): {
    show: Ref<any, any>;
    dropdownRef: Ref<any, any>;
    dropdownMenuRef: Ref<any, any>;
    clickEventRef: Ref<any, any>;
    showDropMenu: (e?: Event) => void;
    hoverDropdown: (e?: MouseEvent) => void;
    leftButtonClick: () => void;
    closeDropMenu: () => void;
    selectItem: (model: any) => void;
    resolveSize: (size: any) => string;
};
