import { DesignerHostService, DesignerHTMLElement, DraggingResolveContext, UseDesignerRules } from '../../../designer-canvas';
import { DesignerItemContext } from '../../../designer-canvas';
export interface FormUseDesignerRules extends UseDesignerRules {
    /** 跨组件移动输入类控件，需要同步视图模型中的字段和变量等信息 */
    moveInputBetweenComponent: (sourceElement: DesignerHTMLElement) => void;
    /** 根据当前卡片面板的布局配置，获取输入控件的样式 */
    resolveFormGroupAppearance: (formGroupElementSchema: any) => void;
    /** 添加输入类控件后，将绑定信息同步到视图模型 */
    syncFieldToViewModel: (resolveContext: DraggingResolveContext, editorType: string, groupId?: string, groupName?: string) => void;
}
export declare function useDesignerRules(designItemContext: DesignerItemContext, designerHostService?: DesignerHostService): FormUseDesignerRules;
