import { ExtractPropTypes, PropType } from 'vue';
export declare const dynamicViewProps: {
    /**
     * schema
     */
    schema: {
        type: ObjectConstructor;
        default: null;
    };
    /**
     * 组件值
     */
    modelValue: {
        type: PropType<Record<string, any>>;
        default: null;
    };
    /**
     * 回调
     */
    callback: {
        type: PropType<(type: string, ...args: unknown[]) => any>;
        default: () => void;
    };
};
export type DynamicViewProps = ExtractPropTypes<typeof dynamicViewProps>;
