import { Ref } from "vue";
import { BoundEventItem, Command, ComponentItem, EventItem, InteractionItem, InternalCommand, SwitchOption } from "../types";
export interface UseEventsEditorUtil {
    isContextDependent: (controllerId: string, commandHandlerName: string) => boolean;
    setComponentLists: (controllerItem: any, commandItem: any, initialData: InternalCommand) => any;
}
export interface UseOriginalData {
    getOriginalData: (initialData: InternalCommand) => void;
    initBoundEvents: (boundEvents: BoundEventItem[], unboundEvents: EventItem[], internalCommandList: Command[]) => void;
    initUnboundEvents: (unboundEvents: EventItem[], internalCommandList: Command[]) => void;
}
export interface UseTargetComponent {
    initTargetComponent: (initialData: InternalCommand) => void;
}
export interface UseInteraction {
    addNewInteraction: (selectedEvent?: EventItem) => void;
    collapseInteractions: () => void;
    deleteInteracton: (interactionIndex: number) => void;
    interactions: Ref<InteractionItem[]>;
    loadInteractions: () => void;
    toggleMethodInInteraction: (interactionIndex: number) => void;
}
export interface UseEvents {
    allEvents: Ref<EventItem[]>;
    boundEvents: Ref<BoundEventItem[]>;
    candidateEvents: Ref<EventItem[]>;
    excludeFromCandidates: (selectedEvent: EventItem) => void;
    loadEvents: () => void;
    resetBoundEvents: () => void;
    unBoundEvent: (eventToBeUnBound: EventItem) => void;
}
export interface UseMethods {
    controllers: Ref<Command[]>;
    onClosed: (actionIndex: number) => void;
    onCurrentCommandChanged: (currentCommand: any[], actionIndex: number, commandItemIndex: number) => void;
    toggleSelectingMethod: (switchOption: SwitchOption) => void;
    emitFinalState: (addNewFunctionState: any, event: any) => void;
    getComponentList: () => ComponentItem[];
    updateTarget: (command: any) => void;
    updateCommandHasPath: (controllerItem: any, commandItem: any) => any;
    addNewController: (webCommand: any) => void;
    checkIfNewControllerExists: (importData: any) => boolean;
    getMethodsOnViewModel: () => Array<any>;
    getViewModeId: () => string;
}
