export declare const events: {
    label: string;
    name: string;
}[];
export declare const boundEventsList: {
    boundEvent: {
        label: string;
        name: string;
    };
    controller: {
        id: string;
        label: string;
        name: string;
    };
    command: {
        id: string;
        label: string;
        name: string;
        handlerName: string;
        params: {
            name: string;
            shownName: string;
            value: string;
            defaultValue: null;
        }[];
        cmpId: string;
        isNewGenerated: boolean;
        isInvalid: boolean;
        targetComponent: string;
    };
}[];
export declare const initialData: {
    propertyID: string;
    propertyType: string;
    /** 内置构件显示的命令列表 */
    internalCommandList: {
        controllerName: {
            id: string;
            label: string;
            name: string;
        };
        controllerList: {
            id: string;
            label: string;
            name: string;
            handlerName: string;
        }[];
    }[];
    /** (事件设定)可绑定事件默认列表; */
    events: {
        label: string;
        name: string;
    }[];
    /** 已绑定的事件（拼接已有的参数值，拼接当前事件->待集成-从dom结构中取值，事件及对应的字符串） */
    boundEventsList: never[];
    /** 视图模型已有命令 */
    viewModel: never[];
    /** 目标组件对应的所有可选的组件 */
    componentLists: {
        componentId: string;
        viewModelId: string;
    }[];
    /** 所有组件列表 */
    allComponentList: {
        componentId: string;
        viewModelId: string;
    }[];
    /** 初始为空，用于存储用户点击「导入新命令」的控制器值 */
    newController: never[];
    isAddControllerMethod: boolean;
    getEventList: () => {
        events: {
            label: string;
            name: string;
        }[];
        boundEventsList: never[];
    };
};
