import { ExtractPropTypes, PropType } from "vue";
import { ExpressionOptions } from "../composition/types";
export declare const conditionGridProps: {
    conditions: {
        type: ArrayConstructor;
        default: never[];
    };
    fields: {
        type: {
            (arrayLength: number): {
                label: string;
                value: string;
            }[];
            (...items: {
                label: string;
                value: string;
            }[]): {
                label: string;
                value: string;
            }[];
            new (arrayLength: number): {
                label: string;
                value: string;
            }[];
            new (...items: {
                label: string;
                value: string;
            }[]): {
                label: string;
                value: string;
            }[];
            isArray(arg: any): arg is any[];
            readonly prototype: any[];
            from<T>(arrayLike: ArrayLike<T>): T[];
            from<T_1, U>(arrayLike: ArrayLike<T_1>, mapfn: (v: T_1, k: number) => U, thisArg?: any): U[];
            from<T_2>(iterable: Iterable<T_2> | ArrayLike<T_2>): T_2[];
            from<T_3, U_1>(iterable: Iterable<T_3> | ArrayLike<T_3>, mapfn: (v: T_3, k: number) => U_1, thisArg?: any): U_1[];
            of<T_4>(...items: T_4[]): T_4[];
            readonly [Symbol.species]: ArrayConstructor;
        };
        default: never[];
    };
    activeIndex: {
        type: NumberConstructor;
        default: number;
    };
    formatter: {
        type: FunctionConstructor;
        default: (cell: any, data: any) => string;
    };
    enableExpression: {
        type: BooleanConstructor;
        default: boolean;
    };
    expressionOptions: {
        type: PropType<ExpressionOptions>;
        default: null;
    };
    formContextData: {
        type: ObjectConstructor;
        default: {};
    };
    singleValue: {
        type: BooleanConstructor;
        default: boolean;
    };
    idField: {
        type: StringConstructor;
        default: string;
    };
    textField: {
        type: StringConstructor;
        default: string;
    };
    valueField: {
        type: StringConstructor;
        default: string;
    };
};
export type ConditionGridProps = ExtractPropTypes<typeof conditionGridProps>;
