export declare enum Compare {
    Equal = 0,
    NotEqual = 1,
    Greater = 2,
    GreaterOrEqual = 3,
    Less = 4,
    LessOrEqual = 5,
    Like = 6,
    LikeStartWith = 7,
    LikeEndWith = 8,
    NotLike = 9,
    NotLikeStartWith = 10,
    NotLikeEndWith = 11,
    Is = 12,
    IsNot = 13,
    In = 14,
    NotIn = 15
}
export declare enum FilterRelation {
    Empty = 0,
    And = 1,
    Or = 2
}
export declare enum ValueType {
    Value = 0,
    Expression = 1,
    Variable = 2
}
export declare enum SortType {
    Asc = "asc",
    Desc = "desc"
}
export interface FilterSortCondition {
    lbracket?: string;
    filterField?: string;
    compare?: Compare;
    value?: string;
    rbracket?: string;
    relation?: FilterRelation;
    expresstype?: ValueType;
    sortField?: string;
    sortType?: SortType;
}
export type FilterCondition = Pick<FilterSortCondition, 'lbracket' | 'filterField' | 'compare' | 'value' | 'rbracket' | 'relation' | 'expresstype'>;
export type SortCondition = Pick<FilterSortCondition, 'sortField' | 'sortType'>;
export interface ExpressionOptions {
    entities: Array<any>;
    variables: Array<any>;
    disabledFunctions: any;
    singleExpand: boolean;
    showMessage: boolean;
    validateMessage: string;
}
