/**
 * Copyright (c) 2020 - present, Inspur Genersoft Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { ExtractPropTypes, PropType, RenderFunction } from 'vue';
export declare const htmlTemplateProps: {
    /** 渲染函数 */
    renderFunction: {
        type: PropType<RenderFunction>;
    };
};
export type HtmlTemplateProps = ExtractPropTypes<typeof htmlTemplateProps>;
export declare const propsResolver: (schemaValue?: Record<string, any>, mergeDefaults?: boolean) => Record<string, any>;
export declare const htmlTemplateDesignProps: {
    /** html模板 */
    html: {
        type: StringConstructor;
        default: string;
    };
};
export type HtmlTemplateDesignProps = ExtractPropTypes<typeof htmlTemplateDesignProps>;
export declare const designPropsResolver: (schemaValue?: Record<string, any>, mergeDefaults?: boolean) => Record<string, any>;
