/**
 * Copyright (c) 2020 - present, Inspur Genersoft Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { ExtractPropTypes, PropType } from 'vue';
import { ParameterDescriptor, FormContextData } from './composition/types';
export type BeforeOpenFunction = (...params: any) => (Promise<{
    formContextData?: any;
    parameterDescriptors?: ParameterDescriptor[];
}> | void);
export declare const jsonEditorProps: {
    /** 组件值 */
    modelValue: {
        type: StringConstructor;
        default: string;
    };
    /** 待配置参数的描述信息 */
    parameterDescriptors: {
        type: PropType<ParameterDescriptor[]>;
        default: never[];
    };
    /** 表单上下文数据，用于传递给通用参数编辑器组件 */
    formContextData: {
        type: PropType<FormContextData>;
        default: {};
    };
    /** 打开编辑框前回调 */
    beforeOpen: {
        type: PropType<BeforeOpenFunction>;
        default: null;
    };
    dialogTitle: {
        type: StringConstructor;
        default: string;
    };
    keyColumnTitle: {
        type: StringConstructor;
        default: string;
    };
    valueColumnTitle: {
        type: StringConstructor;
        default: string;
    };
    operationColumnTitle: {
        type: StringConstructor;
        default: string;
    };
    keyColumnPlaceholder: {
        type: StringConstructor;
        default: string;
    };
    valueColumnPlaceholder: {
        type: StringConstructor;
        default: string;
    };
    addButtonText: {
        type: StringConstructor;
        default: string;
    };
};
export type JsonEditorProps = ExtractPropTypes<typeof jsonEditorProps>;
export declare const propsResolver: (schemaValue?: Record<string, any>, mergeDefaults?: boolean) => Record<string, any>;
