export declare class LocaleService {
    localeId: string;
    private localeData;
    static langData: any;
    static localeId: string;
    constructor(localeId: string, localeData: any);
    /** 获取语言资源
     *  path : 资源路径，如:
     *  getResources('zh-CHS') // 返回所有中文语言资源
     *  getResources('zh-CHS.lookup') // 返回所有中文下帮助的资源
     */
    static getResources(path?: string): any;
    static getComponentOptions(ctrlName: any): any;
    /** 合并现有的多语资源 */
    static setLocaleData(localeData: null | undefined, localeId: any): void;
    static appendLanguageResource(key: string, data: any, lang?: string): void;
    static getLocaleValue(propertyName: string): any;
    /**
    * 获取对象中指定字段的值。 field: 可以为带有层级结构的路径，如： user.firstName | name 等
    * data: 获取字段的数据源，一般为JSON对象
    * safe: 为true, 将html字符进行转码输出，默认为 false
    */
    static getValue(field: string, data: any, safe?: boolean): any;
    static formatterValue(val: any): any;
    static escapeHtml(str: any): any;
}
