import { ExtractPropTypes, PropType } from 'vue';
import { UserDataService } from '../composition/use-user-data';
import { UseHttpComposition } from '../composition/use-http';
export declare const lookupModalContainerProps: {
    title: {
        type: StringConstructor;
    };
    height: {
        type: NumberConstructor;
        default: number;
    };
    draggable: {
        type: BooleanConstructor;
        default: boolean;
    };
    enableFavorite: {
        type: BooleanConstructor;
        default: boolean;
    };
    useHttpComposition: {
        type: PropType<UseHttpComposition>;
        default: {};
    };
    userDataService: {
        type: PropType<UserDataService>;
        default: {};
    };
    useDialog: {
        type: ObjectConstructor;
        default: {};
    };
    selectionsManager: {
        type: ObjectConstructor;
        default: {};
    };
    showSelectedList: {
        type: BooleanConstructor;
        default: boolean;
    };
    showIncludeChildNodes: {
        type: ObjectConstructor;
        default: {
            show: boolean;
            value: boolean;
        };
    };
    showCascadeControl: {
        type: BooleanConstructor;
        default: boolean;
    };
    cascadeValue: {
        type: StringConstructor;
        default: string;
    };
    isMaximized: {
        type: BooleanConstructor;
        default: boolean;
    };
};
export type LookupModalContainerProps = ExtractPropTypes<typeof lookupModalContainerProps>;
