import { Ref } from "vue";
import { LookupHttpResult, LookupHttpService, TreeInfo } from "./types";
import { LookupStates } from "./use-state";
import { LookupProps } from "../lookup.props";
export declare const LOOKUP_HTTP_COMPOSITION = "F_LOOKUP_HTTP_COMPOSITION_TOKEN";
export interface UseHttpComposition {
    includeChilds: Ref<boolean>;
    updateIncludeChilds: (checked: boolean) => void;
    idValues: Ref<any>;
    loadData: (event: any, callback: (data: LookupHttpResult) => void) => void;
    getData: (params: any) => Promise<any>;
    updateSearchFieldTitle: (searchFields: any[], columns: any[]) => any[];
    getPathCode: (data: any, treeInfo: TreeInfo) => string;
    getChildNodes: (node: any) => Array<any>;
    lookupStates: LookupStates;
    httpService?: LookupHttpService;
    lookupRequest: () => (uri: any, params: any) => Promise<LookupHttpResult>;
    expandAllNodes: (treeNodes: any[], isNavigation?: boolean) => any[];
    getIdQueryParams: () => any;
    setTreeInfo: (resData: TreeInfo, isNavigation?: boolean) => void;
    getFieldValue: (data: any, field: string) => any;
}
export declare function useHttp(props: LookupProps, context: any): UseHttpComposition;
