import { LookupProps } from "../lookup.props";
import { UseHttpComposition } from "./use-http";
export interface LookupUserData {
    pageSize?: number;
    tabIndex?: string;
    cascadeStatus?: boolean;
    favorites?: Array<string>;
    size?: Record<string, any>;
}
export interface UserDataState {
    key: string;
    data: LookupUserData;
    favoriteItems?: any[];
}
export declare const LOOKUP_USER_DATA_SERVICE = "F_LOOKUP_USER_DATA_SERVICE";
export interface UserDataService {
    userDataState: any;
    saveUserData: () => Promise<any>;
    getFavoriteData: () => Promise<any>;
    getUserData: () => Promise<any>;
    setDialogSize: (size: {
        width: number;
        height: number;
    }) => void;
}
export declare function useUserData(props: LookupProps, useHttpComposition: UseHttpComposition): UserDataService;
