/**
 * Copyright (c) 2020 - present, Inspur Genersoft Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { ExtractPropTypes, PropType } from 'vue';
import { TargetType, FetchNodeApi } from './composition/types';
export declare const menuLookupProps: {
    /** 选择的目标类型 */
    targetType: {
        type: PropType<TargetType>;
        default: string;
    };
    /** 获取“菜单树”或“应用树”数据的接口地址 */
    fetchNodeApi: {
        type: PropType<FetchNodeApi>;
        require: boolean;
    };
    /** 组件值 */
    modelValue: {
        type: StringConstructor;
        default: string;
    };
};
export type MenuLookupProps = ExtractPropTypes<typeof menuLookupProps>;
export declare const propsResolver: (schemaValue?: Record<string, any>, mergeDefaults?: boolean) => Record<string, any>;
