import { ExceptionInfo } from './message-box.props';
export interface MessageBoxOption {
    width?: number;
    type: string;
    title?: string;
    detail?: string;
    okButtonText?: string;
    cancelButtonText?: string;
    exceptionInfo?: ExceptionInfo;
    acceptCallback?: () => void;
    rejectCallback?: () => void;
    buttons?: Array<any>;
}
export default class MessageBoxService {
    static show(options: MessageBoxOption): any;
    static info(message: string, detail: string): void;
    static warning(message: string, detail: string): void;
    static success(message: string, detail: string): void;
    static error(message: string, detail: string, date?: string): any;
    static prompt(message: string, detail: string): void;
    static question(message: string, detail: string, acceptCallback: () => void, rejectCallback: () => void): void;
}
