/**
 * Copyright (c) 2020 - present, Inspur Genersoft Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import type { Plugin } from 'vue';
import FModal from './src/modal.component';
import FModalService from './src/composition/modal.service';
export * from './src/composition/type';
export * from './src/modal.props';
export declare const F_MODAL_SERVICE_TOKEN: unique symbol;
export { FModal, FModalService };
declare const _default: {
    new (...args: any[]): import("vue").CreateComponentPublicInstanceWithMixins<Readonly<{
        render?: Function | undefined;
        class?: string | undefined;
        width?: number | undefined;
        allowClickMaskToClose?: boolean | undefined;
        beforeClose?: Function | undefined;
        maskClass?: string | undefined;
        title?: string | undefined;
        height?: number | undefined;
        buttons?: import("./src/composition/type").ModalButton[] | undefined;
        modelValue?: boolean | undefined;
        mask?: boolean | undefined;
        showHeader?: boolean | undefined;
        showButtons?: boolean | undefined;
        fitContent?: boolean | undefined;
        showCloseButton?: boolean | undefined;
        showMaxButton?: boolean | undefined;
        containment?: HTMLElement | undefined;
        resizeable?: boolean | undefined;
        draggable?: boolean | undefined;
        dragHandle?: import("./src/modal.props").DragHandleType | undefined;
        closedCallback?: Function | undefined;
        resizeHandle?: Function | undefined;
        acceptCallback?: Function | undefined;
        rejectCallback?: Function | undefined;
        enableEsc?: boolean | undefined;
        enableEnter?: boolean | undefined;
        dialogType?: string | undefined;
        src?: string | undefined;
        footerHeight?: number | undefined;
        minHeight?: number | undefined;
        maxHeight?: number | undefined;
        minWidth?: number | undefined;
        maxWidth?: number | undefined;
    }> & Readonly<{}>, () => any, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, import("vue").PublicProps, {
        render: Function;
        class: string;
        width: number;
        allowClickMaskToClose: boolean;
        beforeClose: Function;
        maskClass: string;
        title: string;
        height: number;
        buttons: import("./src/composition/type").ModalButton[];
        modelValue: boolean;
        mask: boolean;
        showHeader: boolean;
        showButtons: boolean;
        fitContent: boolean;
        showCloseButton: boolean;
        showMaxButton: boolean;
        containment: HTMLElement;
        resizeable: boolean;
        draggable: boolean;
        dragHandle: import("./src/modal.props").DragHandleType;
        closedCallback: Function;
        resizeHandle: Function;
        acceptCallback: Function;
        rejectCallback: Function;
        enableEsc: boolean;
        enableEnter: boolean;
        dialogType: string;
        src: string;
        footerHeight: number;
    }, true, {}, {}, import("vue").GlobalComponents, import("vue").GlobalDirectives, string, {}, any, import("vue").ComponentProvideOptions, {
        P: {};
        B: {};
        D: {};
        C: {};
        M: {};
        Defaults: {};
    }, Readonly<{
        render?: Function | undefined;
        class?: string | undefined;
        width?: number | undefined;
        allowClickMaskToClose?: boolean | undefined;
        beforeClose?: Function | undefined;
        maskClass?: string | undefined;
        title?: string | undefined;
        height?: number | undefined;
        buttons?: import("./src/composition/type").ModalButton[] | undefined;
        modelValue?: boolean | undefined;
        mask?: boolean | undefined;
        showHeader?: boolean | undefined;
        showButtons?: boolean | undefined;
        fitContent?: boolean | undefined;
        showCloseButton?: boolean | undefined;
        showMaxButton?: boolean | undefined;
        containment?: HTMLElement | undefined;
        resizeable?: boolean | undefined;
        draggable?: boolean | undefined;
        dragHandle?: import("./src/modal.props").DragHandleType | undefined;
        closedCallback?: Function | undefined;
        resizeHandle?: Function | undefined;
        acceptCallback?: Function | undefined;
        rejectCallback?: Function | undefined;
        enableEsc?: boolean | undefined;
        enableEnter?: boolean | undefined;
        dialogType?: string | undefined;
        src?: string | undefined;
        footerHeight?: number | undefined;
        minHeight?: number | undefined;
        maxHeight?: number | undefined;
        minWidth?: number | undefined;
        maxWidth?: number | undefined;
    }> & Readonly<{}>, () => any, {}, {}, {}, {
        render: Function;
        class: string;
        width: number;
        allowClickMaskToClose: boolean;
        beforeClose: Function;
        maskClass: string;
        title: string;
        height: number;
        buttons: import("./src/composition/type").ModalButton[];
        modelValue: boolean;
        mask: boolean;
        showHeader: boolean;
        showButtons: boolean;
        fitContent: boolean;
        showCloseButton: boolean;
        showMaxButton: boolean;
        containment: HTMLElement;
        resizeable: boolean;
        draggable: boolean;
        dragHandle: import("./src/modal.props").DragHandleType;
        closedCallback: Function;
        resizeHandle: Function;
        acceptCallback: Function;
        rejectCallback: Function;
        enableEsc: boolean;
        enableEnter: boolean;
        dialogType: string;
        src: string;
        footerHeight: number;
    }>;
    __isFragment?: undefined;
    __isTeleport?: undefined;
    __isSuspense?: undefined;
} & import("vue").ComponentOptionsBase<Readonly<{
    render?: Function | undefined;
    class?: string | undefined;
    width?: number | undefined;
    allowClickMaskToClose?: boolean | undefined;
    beforeClose?: Function | undefined;
    maskClass?: string | undefined;
    title?: string | undefined;
    height?: number | undefined;
    buttons?: import("./src/composition/type").ModalButton[] | undefined;
    modelValue?: boolean | undefined;
    mask?: boolean | undefined;
    showHeader?: boolean | undefined;
    showButtons?: boolean | undefined;
    fitContent?: boolean | undefined;
    showCloseButton?: boolean | undefined;
    showMaxButton?: boolean | undefined;
    containment?: HTMLElement | undefined;
    resizeable?: boolean | undefined;
    draggable?: boolean | undefined;
    dragHandle?: import("./src/modal.props").DragHandleType | undefined;
    closedCallback?: Function | undefined;
    resizeHandle?: Function | undefined;
    acceptCallback?: Function | undefined;
    rejectCallback?: Function | undefined;
    enableEsc?: boolean | undefined;
    enableEnter?: boolean | undefined;
    dialogType?: string | undefined;
    src?: string | undefined;
    footerHeight?: number | undefined;
    minHeight?: number | undefined;
    maxHeight?: number | undefined;
    minWidth?: number | undefined;
    maxWidth?: number | undefined;
}> & Readonly<{}>, () => any, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, {
    render: Function;
    class: string;
    width: number;
    allowClickMaskToClose: boolean;
    beforeClose: Function;
    maskClass: string;
    title: string;
    height: number;
    buttons: import("./src/composition/type").ModalButton[];
    modelValue: boolean;
    mask: boolean;
    showHeader: boolean;
    showButtons: boolean;
    fitContent: boolean;
    showCloseButton: boolean;
    showMaxButton: boolean;
    containment: HTMLElement;
    resizeable: boolean;
    draggable: boolean;
    dragHandle: import("./src/modal.props").DragHandleType;
    closedCallback: Function;
    resizeHandle: Function;
    acceptCallback: Function;
    rejectCallback: Function;
    enableEsc: boolean;
    enableEnter: boolean;
    dialogType: string;
    src: string;
    footerHeight: number;
}, {}, string, {}, import("vue").GlobalComponents, import("vue").GlobalDirectives, string, import("vue").ComponentProvideOptions> & import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps & Plugin;
export default _default;
