import { ExtractPropTypes } from 'vue';
export type SortType = 'asc' | 'desc';
export interface OrderedItem {
    id: string;
    name: string;
    order: SortType;
}
export declare const orderProps: {
    /** 排序列数据源 */
    dataSource: {
        type: {
            (arrayLength: number): object[];
            (...items: object[]): object[];
            new (arrayLength: number): object[];
            new (...items: object[]): object[];
            isArray(arg: any): arg is any[];
            readonly prototype: any[];
            from<T>(arrayLike: ArrayLike<T>): T[];
            from<T_1, U>(arrayLike: ArrayLike<T_1>, mapfn: (v: T_1, k: number) => U, thisArg?: any): U[];
            from<T_2>(iterable: Iterable<T_2> | ArrayLike<T_2>): T_2[];
            from<T_3, U_1>(iterable: Iterable<T_3> | ArrayLike<T_3>, mapfn: (v: T_3, k: number) => U_1, thisArg?: any): U_1[];
            of<T_4>(...items: T_4[]): T_4[];
            readonly [Symbol.species]: ArrayConstructor;
        };
        default: never[];
    };
    /** 当前排序数组 */
    items: {
        type: {
            (arrayLength: number): OrderedItem[];
            (...items: OrderedItem[]): OrderedItem[];
            new (arrayLength: number): OrderedItem[];
            new (...items: OrderedItem[]): OrderedItem[];
            isArray(arg: any): arg is any[];
            readonly prototype: any[];
            from<T>(arrayLike: ArrayLike<T>): T[];
            from<T_1, U>(arrayLike: ArrayLike<T_1>, mapfn: (v: T_1, k: number) => U, thisArg?: any): U[];
            from<T_2>(iterable: Iterable<T_2> | ArrayLike<T_2>): T_2[];
            from<T_3, U_1>(iterable: Iterable<T_3> | ArrayLike<T_3>, mapfn: (v: T_3, k: number) => U_1, thisArg?: any): U_1[];
            of<T_4>(...items: T_4[]): T_4[];
            readonly [Symbol.species]: ArrayConstructor;
        };
        default: never[];
    };
};
export type OrderProps = ExtractPropTypes<typeof orderProps>;
export declare const propsResolver: (schemaValue?: Record<string, any>, mergeDefaults?: boolean) => Record<string, any>;
