/**
 * Copyright (c) 2020 - present, Inspur Genersoft Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { ExtractPropTypes, PropType } from 'vue';
export type PopoverPlacement = 'top' | 'bottom' | 'left' | 'right' | 'auto' | 'bottom-left' | 'top-left';
export declare const popoverProps: {
    id: {
        type: StringConstructor;
    };
    arrowOffsetX: {
        type: NumberConstructor;
        default: number;
    };
    class: {
        type: StringConstructor;
    };
    customStyles: {
        type: PropType<Record<string, any>>;
        default: null;
    };
    fitContent: {
        type: BooleanConstructor;
        default: boolean;
    };
    host: {
        type: PropType<any>;
    };
    leftBoundary: {
        type: PropType<any>;
    };
    keepWidthWithReference: {
        type: BooleanConstructor;
        default: boolean;
    };
    minWidth: {
        type: NumberConstructor;
        default: number;
    };
    offsetX: {
        type: PropType<any>;
        default: import("vue").Ref<number, number>;
    };
    placement: {
        type: PropType<PopoverPlacement>;
        default: string;
    };
    reference: {
        type: PropType<any>;
    };
    rightBoundary: {
        type: PropType<any>;
    };
    showArrow: {
        type: BooleanConstructor;
        default: boolean;
    };
    title: {
        type: StringConstructor;
    };
    visible: {
        type: BooleanConstructor;
        default: boolean;
    };
    zIndex: {
        type: NumberConstructor;
        default: number;
    };
};
export type PopoverProps = ExtractPropTypes<typeof popoverProps>;
