import { DesignerComponentInstance } from '../../../../designer-canvas';
import { PropertyChangeObject } from "./property-entity";
/**
 * 控件属性基类
 */
export declare class BaseControlProperty {
    componentId: string;
    viewModelId: string;
    eventsEditorUtils: any;
    formSchemaUtils: any;
    formMetadataConverter: any;
    designViewModelUtils: any;
    designViewModelField: any;
    controlCreatorUtils: any;
    designerHostService: any;
    schemaService: any;
    metadataService: any;
    protected propertyConfig: {
        type: string;
        categories: {};
    };
    constructor(componentId: string, designerHostService: any);
    getTableInfo(): any;
    setDesignViewModelField(propertyData: any): void;
    getBasicPropConfig(propertyData: any): any;
    protected getAppearanceConfig(propertyData?: null, properties?: {}, setPropertyRelates?: (changeObject: any, propertyData: any, parameters: any) => any): any;
    protected getPropertyEditorParams(propertyData: any, propertyTypes?: any, propertyName?: string, constInfos?: {}, variableInfos?: {}): {
        type: string;
        propertyTypes: any;
    };
    protected getVisibleProperty(propertyData: any, position?: string): {
        visible: {
            title: string;
            type: string;
            description: string;
            editor: {
                type: string;
                propertyTypes: any;
            };
        };
    };
    /**
     * 获取行为
     * @param propertyData
     * @param viewModelId
     * @returns
     */
    getBehaviorConfig(propertyData: any, position?: string, properties?: {}, setPropertyRelates?: any): any;
    /**
     * 当多值编辑器变更时
     * @param propertyData
     * @param changeObject
     */
    afterMutilEditorChanged(propertyData: any, changeObject: any): void;
    /**
     *
     * @param propertyId
     * @param componentInstance
     * @returns
     */
    updateElementByParentContainer(propertyId: string, componentInstance: DesignerComponentInstance): void;
    /**
     * 属性编辑器，在编辑过程中会新增变量，此处需要将新增的变量追加到ViewModel中
     * @param changeObject
     * @param viewModelId
     * @returns
     */
    addNewVariableToViewModel(changeObject: PropertyChangeObject, viewModelId: string): void;
    /**
     * 更新表达式到expressions节点
     * @param changeObject
     */
    updateExpressionValue(changeObject: PropertyChangeObject): void;
    /**
     * 属性类型切换为非表达式后，清除原表达式
     * @param changeObject
     * @param propertyData
     * @returns
     */
    clearExpression(changeObject: PropertyChangeObject, propertyData: any): void;
    getExpressionOptions(propertyData: any, targetType: 'Field' | 'Button' | 'Container', expressionType: string): {
        dialogTitle: string;
        singleExpand: boolean;
        showMessage: boolean;
        beforeOpen: () => any;
        expressionInfo: {
            value: any;
            targetId: any;
            targetType: "Field" | "Button" | "Container";
            expressionType: string;
        };
    };
    getRealTargetType(propertyData: any): "Field" | "Button" | "Container";
}
