export interface RuleModel {
    id: string;
    type: 'compute' | 'dependency' | 'validate' | 'visible' | 'readonly' | 'required' | 'dataPicking' | string;
    value: string;
    message?: string;
    elementId?: string;
    messageType?: string;
}
export interface ExpressionModel {
    target: string;
    rules: Array<RuleModel>;
    targetType: string;
}
export declare class ExpressionProperty {
    private formSchemaService;
    private sessionVariables;
    constructor(formSchemaService: any);
    private getExpressionRule;
    private getContextFormVariables;
    private createTreeNode;
    private buildEntityFieldsTreeData;
    private buildChildEntityTreeData;
    private getEntitiesTreeData;
    getEntitiesAndVariables(): {
        entities: never[] | {
            entityCode: any;
            fields: {
                data: {
                    id: any;
                    name: any;
                    bindingPath: any;
                    parents: string[];
                };
                children: any[];
            }[];
        };
        variables: {
            session: {
                name: string;
                items: {
                    key: string;
                    name: string;
                    description: string;
                }[];
                visible: boolean;
            };
            forms: {
                name: string;
                items: any;
                visible: boolean;
            };
        };
    };
    private onBeforeOpenExpression;
    private buildRule;
    private getExpressionData;
    private updateExpression;
    private expressionNames;
    private getExpressionConverter;
    private getExpressionEditorOptions;
    private getExpressionInfo;
    getExpressionConfig(propertyData: any, type: 'Field' | 'Button' | 'Container', expressionTypes?: string[], callback?: (rule: Record<string, any>) => void): {
        description: string;
        title: string;
        properties: {
            [x: string]: any;
        };
    };
    getExpressionOptions(propertyData: any, targetType: 'Field' | 'Button' | 'Container', expressionType: string): {
        dialogTitle: string;
        singleExpand: boolean;
        showMessage: boolean;
        beforeOpen: () => any;
        expressionInfo: {
            value: any;
            targetId: any;
            targetType: "Field" | "Button" | "Container";
            expressionType: string;
        };
    };
}
