import { FormPropertyChangeObject } from "./property-entity";
export declare class SchemaDOMMapping {
    /**
     * <字段类型,可配置的控件类型列表>的映射
     */
    static fieldControlTypeMapping: {
        String: {
            key: string;
            value: string;
        }[];
        Text: {
            key: string;
            value: string;
        }[];
        Decimal: {
            key: string;
            value: string;
        }[];
        Integer: {
            key: string;
            value: string;
        }[];
        Number: {
            key: string;
            value: string;
        }[];
        BigNumber: {
            key: string;
            value: string;
        }[];
        Date: {
            key: string;
            value: string;
        }[];
        DateTime: {
            key: string;
            value: string;
        }[];
        Boolean: {
            key: string;
            value: string;
        }[];
        Enum: {
            key: string;
            value: string;
        }[];
        Object: {
            key: string;
            value: string;
        }[];
    };
    /**
     * 根据绑定字段类型获取可用的输入类控件
     */
    static getEditorTypesByMDataType(fieldType: string, controlType?: string): any;
    /**
     * 获取所有输入类控件
     */
    static getAllInputTypes(): {
        key: string;
        value: string;
    }[];
    /**
     * 提供schema字段基础属性和DOM控件属性的映射
     * @param control 控件元数据
     */
    static mappingDomPropAndSchemaProp(control: any, changeObject?: FormPropertyChangeObject): any[];
}
