/**
 * Copyright (c) 2020 - present, Inspur Genersoft Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { ExtractPropTypes, PropType } from 'vue';
type ShowMode = 'panel' | 'sidebar';
export declare const propertyPanelProps: {
    width: {
        type: StringConstructor;
        default: string;
    };
    height: {
        type: NumberConstructor;
        default: number;
    };
    isWidePanel: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 是否启用搜索 */
    enableSearch: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 使用模式 */
    mode: {
        type: PropType<ShowMode>;
        default: string;
    };
    /** 是否持有面板的隐藏显示状态 */
    isPersitOpenState: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** isPersitOpenState=true时，控制面板是否隐藏显示 */
    isShowPanel: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 属性名 */
    propertyName: {
        type: StringConstructor;
        default: string;
    };
    /** 属性类型 */
    propertyConfig: {
        type: {
            (arrayLength: number): object[];
            (...items: object[]): object[];
            new (arrayLength: number): object[];
            new (...items: object[]): object[];
            isArray(arg: any): arg is any[];
            readonly prototype: any[];
            from<T>(arrayLike: ArrayLike<T>): T[];
            from<T_1, U>(arrayLike: ArrayLike<T_1>, mapfn: (v: T_1, k: number) => U, thisArg?: any): U[];
            from<T_2>(iterable: Iterable<T_2> | ArrayLike<T_2>): T_2[];
            from<T_3, U_1>(iterable: Iterable<T_3> | ArrayLike<T_3>, mapfn: (v: T_3, k: number) => U_1, thisArg?: any): U_1[];
            of<T_4>(...items: T_4[]): T_4[];
            readonly [Symbol.species]: ArrayConstructor;
        };
    };
    /** 属性值 */
    propertyData: {
        type: ObjectConstructor;
        default: {};
    };
    /** 是否展示关闭按钮 */
    showCloseBtn: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 当前选中的标签页id */
    selectedTabId: {
        type: StringConstructor;
        default: string;
    };
    /** 是否是白色主题 */
    isWhiteTheme: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** dom结构 */
    schema: {
        type: ObjectConstructor;
        default: {};
    };
    /** 属性变更后事件 */
    propertyChanged: {
        type: FunctionConstructor;
    };
};
export type PropertyPanelProps = ExtractPropTypes<typeof propertyPanelProps>;
export {};
