/**
 * Copyright (c) 2020 - present, Inspur Genersoft Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import type { App } from 'vue';
import FQuerySolution from './src/query-solution.component';
import { useSolutionValidation } from './src/designer/composition/use-validation';
import { useTransfer } from './src/designer/query-solution-config/composition/use-transfer';
import { usePanel } from './src/designer/query-solution-config/composition/use-panel';
export * from './src/query-solution.props';
export * from './src/composition/types';
export * from './src/composition/use-condition';
export * from './src/designer/query-solution-config/composition/types';
export { FQuerySolution, useSolutionValidation, useTransfer, usePanel };
declare const _default: {
    install(app: App): void;
    register(componentMap: Record<string, any>, propsResolverMap: Record<string, any>, configResolverMap: Record<string, any>, resolverMap: Record<string, any>): void;
    registerDesigner(componentMap: Record<string, any>, propsResolverMap: Record<string, any>, configResolverMap: Record<string, any>): void;
};
export default _default;
