import { ExtractPropTypes } from "vue";
export interface ViewOption {
    /** 视图唯一标识 */
    id: string;
    /** 视图标题 */
    title: string;
    /** 视图类型 */
    type: 'Card' | 'Icon' | 'List';
    /** 数据源类型 */
    dataSource: 'Recent' | 'Recommand' | 'Total';
    /** 启用分组 */
    enableGroup?: boolean;
    /** 分组字段 */
    groupField?: string;
    pagination?: boolean;
    groupFormatter?: (value: any, groupData: any) => string;
}
export type SelectSchemaViewType = 'Tabs' | 'NavList';
export declare const schemaSelectorProps: Record<string, any>;
export type SchemaSelectorProps = ExtractPropTypes<typeof schemaSelectorProps>;
