import { BaseControlProperty } from "../../../property-panel/src/composition/entity/base-property";
export declare class SectionProperty extends BaseControlProperty {
    constructor(componentId: string, designerHostService: any);
    getPropertyConfig(propertyData: any): {
        type: string;
        categories: {};
    };
    getAppearanceProperties(propertyData: any): {
        title: string;
        description: string;
        properties: {
            class: {
                description: string;
                title: string;
            };
            style: {
                description: string;
                title: string;
            };
            fill: {
                title: string;
                type: string;
                description: string;
            };
            showHeader: {
                title: string;
                type: string;
                description: string;
            };
            mainTitle: {
                title: string;
                type: string;
                description: string;
                visible: {
                    showHeader: boolean;
                };
            };
            subTitle: {
                title: string;
                type: string;
                description: string;
                visible: {
                    showHeader: boolean;
                };
            };
            enableAccordion: {
                title: string;
                type: string;
                description: string;
                editor: {
                    type: string;
                    textField: string;
                    valueField: string;
                    idField: string;
                    editable: boolean;
                    data: {
                        key: string;
                        value: string;
                    }[];
                };
                refreshPanelAfterChanged: boolean;
            };
            expandStatus: {
                title: string;
                type: string;
                description: string;
                editor: {
                    type: string;
                    textField: string;
                    valueField: string;
                    data: {
                        name: string;
                        value: boolean;
                    }[];
                    enableClear: boolean;
                };
                visible: boolean;
            };
        };
        setPropertyRelates(changeObject: any, prop: any): void;
    };
    getExtendConfig(propertyData: any): {
        title: string;
        description: string;
        properties: {
            contentClass: {
                title: string;
                type: string;
                description: string;
            };
        };
    };
}
