/**
 * Copyright (c) 2020 - present, Inspur Genersoft Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { ExtractPropTypes } from 'vue';
export type TabType = 'fill' | 'pills' | 'default' | 'one-page';
export type TabPosition = 'left' | 'right' | 'top' | 'bottom';
export type TabHeaderJustifyMode = 'left' | 'center' | 'right';
export declare const tabsProps: Record<string, any>;
export type TabsProps = ExtractPropTypes<typeof tabsProps>;
export declare const tabsPropsResolver: (schemaValue?: Record<string, any>, mergeDefaults?: boolean) => Record<string, any>;
export declare const tabsDesignProps: Record<string, any> & {
    componentId: {
        type: StringConstructor;
        default: string;
    };
};
export type TabsDesignProps = ExtractPropTypes<typeof tabsDesignProps>;
export declare const tabsDesignPropsResolver: (schemaValue?: Record<string, any>, mergeDefaults?: boolean) => Record<string, any>;
export declare const eventHandlerResolver: import("../../dynamic-resolver").EventHandlerResolver;
