import { ExtractPropTypes, PropType } from 'vue';
import { DisabledHoursFunction, DisabledMinutesFunction, DisabledSecondsFunction } from '../composition/types';
export declare const timeProps: {
    modelValue: {
        type: StringConstructor;
        default: string;
    };
    hourStep: {
        type: NumberConstructor;
        default: number;
    };
    minuteStep: {
        type: NumberConstructor;
        default: number;
    };
    secondStep: {
        type: NumberConstructor;
        default: number;
    };
    defaultOpenValue: {
        type: DateConstructor;
        default: null;
    };
    disabledHours: {
        type: PropType<DisabledHoursFunction>;
        default: null;
    };
    disabledMinutes: {
        type: PropType<DisabledMinutesFunction>;
        default: null;
    };
    disabledSeconds: {
        type: PropType<DisabledSecondsFunction>;
        default: null;
    };
    format: {
        type: StringConstructor;
        default: string;
    };
    isOpen: {
        type: BooleanConstructor;
        default: boolean;
    };
    use12Hours: {
        type: BooleanConstructor;
        default: boolean;
    };
    showHeader: {
        type: BooleanConstructor;
        default: boolean;
    };
    hideDisabledElements: {
        type: BooleanConstructor;
        default: boolean;
    };
};
export type TimeProps = ExtractPropTypes<typeof timeProps>;
