import { Ref } from 'vue';
import { TimeValueText } from './types';
export declare class TimeHolder {
    hourStep: number;
    minuteStep: number;
    secondStep: number;
    use12Hours: boolean;
    changedValue: Ref<TimeValueText>;
    format: string;
    private temporaryHours;
    /**
     * @description
     * Same as realHours
     * @see realHours
     */
    get hours(): number | undefined;
    /**
     * @description
     * Set viewHours to realHours
     */
    set hours(value: number | undefined);
    /**
     * @description
     * Value hours
     * Get realHours and its range is [0, 1, 2, ..., 22, 23]
     */
    get realHours(): number | undefined;
    /**
     * @description
     * UI view hours
     * Get viewHours which is selected in `time-picker-panel` and its range is [12, 1, 2, ..., 11]
     */
    get viewHours(): number | undefined;
    private temporaryMinutes;
    get minutes(): number | undefined;
    set minutes(value: number | undefined);
    private temporarySeconds;
    get seconds(): number | undefined;
    set seconds(value: number | undefined);
    /**
     * @description
     * Same as defaultRealHours
     */
    get defaultHours(): number;
    /**
     * @description
     * Get deafultViewHours when defaultOpenValue is setted
     * @see viewHours
     */
    get defaultViewHours(): number;
    /**
     * @description
     * Get defaultRealHours when defaultOpenValue is setted
     * @see realHours
     */
    get defaultRealHours(): number;
    get defaultMinutes(): number;
    get defaultSeconds(): number;
    get default12Hours(): string;
    private temporaryText;
    get text(): string;
    set text(value: string);
    private temporaryValue;
    get value(): Date | undefined;
    set value(value: Date | undefined);
    private temporarySelected12Hours;
    get selected12Hours(): string | undefined;
    set selected12Hours(value: string | undefined);
    private temporaryDefaultOpenValue;
    get defaultOpenValue(): Date;
    set defaultOpenValue(value: Date);
    get isEmpty(): boolean;
    constructor();
    setFormat(value: string): void;
    setHours(value: number, disabled: boolean): this;
    setUse12Hours(value: boolean): this;
    setMinutes(value: number, disabled: boolean): this;
    setSeconds(value: number, disabled: boolean): this;
    setValue(value: Date | undefined, use12Hours?: boolean): this;
    setValueByStep(value: number, step: number): number;
    setDefaultOpenValue(value: Date): this;
    setDefaultValueIfNil(): void;
    private update;
    private clearTimeValue;
    clear(): void;
    private calculateViewHour;
}
