import { ExtractPropTypes, PropType } from 'vue';
import { UploaderOptions } from '../composition/type';
export declare const previewCheckboxProps: {
    checked: {
        type: BooleanConstructor;
        default: boolean;
    };
    id: {
        type: StringConstructor;
        default: string;
    };
    disabled: {
        type: BooleanConstructor;
        default: boolean;
    };
};
export type PreviewCheckboxProps = ExtractPropTypes<typeof previewCheckboxProps>;
/**
 * 进度条组件
 */
export type UploadProgressStatusType = 'success' | 'error' | 'active' | 'normal';
export declare const uploadProgressProps: {
    showInfo: {
        type: BooleanConstructor;
        default: boolean;
    };
    status: {
        type: PropType<UploadProgressStatusType>;
        default: string;
    };
    percent: {
        type: NumberConstructor;
        default: number;
    };
    maxWidth: {
        type: NumberConstructor;
        default: number;
    };
};
export type UploadProgressProps = ExtractPropTypes<typeof uploadProgressProps>;
/**
 * 文件选择组件
 */
export declare const fileSelectProps: {
    /**
    * 按钮文本
    */
    selectText: {
        type: StringConstructor;
        default: string;
    };
    /**
     * 禁用
     */
    disabled: {
        type: BooleanConstructor;
        default: boolean;
    };
    /**
     * 启用多选
     */
    enableMulti: {
        type: BooleanConstructor;
        default: boolean;
    };
    /**
     * 允许上传类型
     */
    accept: {
        type: StringConstructor;
        default: string;
    };
    /**
     * 配置对象
     */
    options: {
        type: PropType<UploaderOptions>;
        default: {};
    };
    /**
     * 已上传附件个数
     */
    uploadedCount: {
        type: NumberConstructor;
        default: number;
    };
    /**
    * 发起服务器端请求，某个组件使用的特殊的参数
    */
    extendConfig: {
        type: ObjectConstructor;
        default: {};
    };
    /**
 * 附件服务器端服务注入的Token
 */
    uploadServerToken: {
        type: StringConstructor;
        default: string;
    };
};
export type FileSelectProps = ExtractPropTypes<typeof fileSelectProps>;
