import { UploaderOptions, UploadFile, FUploadFileExtend, UploadOutput } from "./type";
export declare function formateDateTo(dateValue: string | Date, dateFormat: string): string;
/**
 * 对预览数据数据进行排序
 */
export declare function sortPreviewData(key: string): (x: any, y: any) => 1 | -1;
/**
 * 是否判断有类型限制
 */
export declare function judgeContentTypeLimit(allowedContentTypes: string[]): boolean;
/**
* 判断是否有文件大小的限制
*/
export declare function judegeFileSizeLimit(maxFileSize: string | number): boolean;
export declare function humanizeBytes(bytes: number): string;
/**
 * 格式化
 */
export declare function formatUploadOpts(opts: UploaderOptions, defaultOpts: any): UploaderOptions;
/**
 * 获取文档类型对应的class
 * @param fileName
 */
export declare function getFileTypeClassName(fileName: string): string;
/**
 * 获取上传进度
 */
export declare function getUploadProgress(uploadInfo: UploadOutput): number;
/**
 * 获取真实的文件的大小
 */
export declare function getRealFileSize(fileSize: number | string | undefined): string;
/**
 * 判断是否能编辑
 */
export declare function canEditFile(fileInfo: FUploadFileExtend): boolean;
export declare function makeUploadFile(file: File, index: number): UploadFile;
export declare function changeUploadFileToFileExtend(files: UploadFile[]): FUploadFileExtend[];
/**
 * 应用在服务
 * 判断文件大小是否被允许
 */
export declare function isFileSizeAllowed(maxFileSize: number | undefined, fileSize: number): boolean;
/**
* 判断文件类型是否允许上传
* @param name
*/
export declare function isContentTypeAllowed(allowedContentTypes: string[] | undefined, name: string): boolean;
/**
 * ------------------------------------
 * 提供给默认服务
 * ------------------------------------
 */
export declare function parseResponseHeaders(httpHeaders: string): {} | undefined;
export declare function secondsToHuman(sec: number): string;
