import { ExtractPropTypes, PropType } from 'vue';
import { ValidatorListItem, VerifyTypeItem } from './composition/type';
export declare const verifyDetailProps: {
    /** 表单验证默认显示的分组信息 */
    showType: {
        type: StringConstructor;
        default: string;
    };
    /** 是否默认显示验证信息列表 */
    showList: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 表单验证列表 */
    verifyList: {
        type: {
            (arrayLength: number): ValidatorListItem[];
            (...items: ValidatorListItem[]): ValidatorListItem[];
            new (arrayLength: number): ValidatorListItem[];
            new (...items: ValidatorListItem[]): ValidatorListItem[];
            isArray(arg: any): arg is any[];
            readonly prototype: any[];
            from<T>(arrayLike: ArrayLike<T>): T[];
            from<T_1, U>(arrayLike: ArrayLike<T_1>, mapfn: (v: T_1, k: number) => U, thisArg?: any): U[];
            from<T_2>(iterable: Iterable<T_2> | ArrayLike<T_2>): T_2[];
            from<T_3, U_1>(iterable: Iterable<T_3> | ArrayLike<T_3>, mapfn: (v: T_3, k: number) => U_1, thisArg?: any): U_1[];
            of<T_4>(...items: T_4[]): T_4[];
            readonly [Symbol.species]: ArrayConstructor;
        };
        default: never[];
    };
    verifyType: {
        type: {
            (arrayLength: number): VerifyTypeItem[];
            (...items: VerifyTypeItem[]): VerifyTypeItem[];
            new (arrayLength: number): VerifyTypeItem[];
            new (...items: VerifyTypeItem[]): VerifyTypeItem[];
            isArray(arg: any): arg is any[];
            readonly prototype: any[];
            from<T>(arrayLike: ArrayLike<T>): T[];
            from<T_1, U>(arrayLike: ArrayLike<T_1>, mapfn: (v: T_1, k: number) => U, thisArg?: any): U[];
            from<T_2>(iterable: Iterable<T_2> | ArrayLike<T_2>): T_2[];
            from<T_3, U_1>(iterable: Iterable<T_3> | ArrayLike<T_3>, mapfn: (v: T_3, k: number) => U_1, thisArg?: any): U_1[];
            of<T_4>(...items: T_4[]): T_4[];
            readonly [Symbol.species]: ArrayConstructor;
        };
        default: never[];
    };
    /** 自定义样式 */
    customClass: {
        type: StringConstructor;
        default: string;
    };
    /** 验证信息列表的最大高度 */
    maxHeight: {
        type: NumberConstructor;
        default: number;
    };
    /** 验证信息条目点击事件回调 */
    onValidatorClick: {
        type: PropType<(item: ValidatorListItem) => void>;
    };
};
export type VerifyDetailProps = ExtractPropTypes<typeof verifyDetailProps>;
export declare const propsResolver: (schemaValue?: Record<string, any>, mergeDefaults?: boolean) => Record<string, any>;
